; 
    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    include \masm32\macros\macros.asm
    include macros2.asm

    sqrt32 PROTO :DWORD
    _sqrt32 PROTO :DWORD
    __sqrt32 PROTO :DWORD
    ___sqrt32 PROTO :DWORD
    ____sqrt32 PROTO :DWORD
    f_sqrt PROTO :DWORD
    
; 
    .data 
    .code
; 
start: 
; 
    LOOPCOUNT EQU 5000000

    mov   eax, input("Press enter to begin...",13,10)

    clockctr_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
      invoke sqrt32, 100000000
    clockctr_end
    print ustr$(eax)
    print chr$(" clock cycles",13,10)

    clockctr_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
      invoke _sqrt32, 100000000
    clockctr_end
    print ustr$(eax)
    print chr$(" clock cycles",13,10)

    clockctr_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
      invoke __sqrt32, 100000000
    clockctr_end
    print ustr$(eax)
    print chr$(" clock cycles",13,10)

    clockctr_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
      invoke ___sqrt32, 100000000
    clockctr_end
    print ustr$(eax)
    print chr$(" clock cycles",13,10)

    clockctr_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
      invoke ____sqrt32, 100000000
    clockctr_end
    print ustr$(eax)
    print chr$(" clock cycles",13,10)

    clockctr_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
      invoke f_sqrt, 100000000
    clockctr_end
    print ustr$(eax)
    print chr$(" clock cycles",13,10)

    mov   eax, input(13,10,13,10,"Press enter to exit...")
    exit

align 8
sqrt32 proc uInt:DWORD
    mov edx,uInt
    xor eax,eax
    mov ebx,40000000h
    mov ecx,16          ;********
sqr10:
    add eax,ebx
    cmp eax,edx
    ja  sqr20
    sub edx,eax
    add eax,ebx
    jnz sqr30
sqr20:
    sub eax,ebx
sqr30:
    shr eax,1
    shr ebx,2
    dec ecx             ;********
    jnz sqr10

    cmp eax,edx
    jae @F
    inc eax
  @@:
    ret
sqrt32 endp

align 8
_sqrt32 proc uInt:DWORD
    mov edx,uInt
    xor eax,eax
    mov ebx,40000000h
    ;mov ecx,16          ;********
    ;NOP
    ;NOP
    ;NOP
    ;NOP
    ;NOP   
sqr10:
    add eax,ebx
    cmp eax,edx
    ja  sqr20
    sub edx,eax
    add eax,ebx
    jnz sqr30
sqr20:
    sub eax,ebx
sqr30:
    shr eax,1
    shr ebx,2
    ;dec ecx             ;********
    ;NOP
    jnz sqr10

    cmp eax,edx
    jae @F
    inc eax
  @@:
    ret
_sqrt32 endp

align 8
__sqrt32 proc uInt:DWORD
    mov edx,uInt
    xor eax,eax
    mov ebx,40000000h
    ;mov ecx,16          ;********
sqr10:
    add eax,ebx
    cmp eax,edx
    ja  sqr20
    sub edx,eax
    add eax,ebx
    jnz sqr30
sqr20:
    sub eax,ebx
sqr30:
    shr eax,1
    ;shr ebx,2            ;<--
    shr ebx,1             ;<--
    shr ebx,1             ;<--
    ;dec ecx             ;********
    jnz sqr10

    cmp eax,edx
    jae @F
    inc eax
  @@:
    ret
__sqrt32 endp

align 8
___sqrt32 proc uInt:DWORD
    mov edx,uInt
    xor eax,eax
    mov ebx,80000000h     ;<--
    ;mov ecx,16          ;********
sqr10:
    shr ebx,1             ;<--
    add eax,ebx
    cmp eax,edx
    ja  sqr20
    sub edx,eax
    add eax,ebx
    jnz sqr30
sqr20:
    sub eax,ebx
sqr30:
    shr eax,1
    ;shr ebx,2            ;<--
    shr ebx,1             ;<--
    ;dec ecx             ;********
    jnz sqr10

    cmp eax,edx
    jae @F
    inc eax
  @@:
    ret
___sqrt32 endp

align 8
____sqrt32 proc uInt:DWORD
    mov edx,uInt
    xor eax,eax
    mov ebx,40000000h
    ;mov ecx,16          ;********
sqr10:
    ;add eax,ebx          ;>----+
    cmp eax,edx           ;     |
    lea eax,[eax+ebx]     ;<----+
    ja  sqr20
    sub edx,eax
    add eax,ebx
    jnz sqr30
sqr20:
    sub eax,ebx
sqr30:
    shr ebx,1             ;<--
    shr eax,1
    ;shr ebx,2            ;<--
    shr ebx,1             ;<--
    ;dec ecx             ;********
    jnz sqr10

    cmp eax,edx
    jae @F
    inc eax
  @@:
    ret
____sqrt32 endp

align 8
f_sqrt proc uInt:DWORD
    local result:DWORD
    fild uInt
    fsqrt
    fistp result
    mov eax,result
    ret
f_sqrt endp

; 
end start
